
CON
  _CLKMODE      = XTAL1 + PLL16X                        
  _XINFREQ      = 5_000_000

   DS1820_D_PIN = 17

    SCK      =  0  ' Max6675 Pin
    CS       =  1  ' Max6675 Pin
    So       =  18 ' Max6675 Pin

    TempScale  = 0     '1 is Farienheight   0 is Centegrade
      
    RS = 11        ' LCD Control Pins                   
    RW = 10        ' LCD Control Pins                    
    E  = 9         ' LCD Control Pins

    DBLow  = 12    ' LCD Data Pins
    DBHigh = 15    ' LCD Data Pins

  ' ASCII codes.
    CR  = 13
    LF  = 10
    PSTClearScreen = 16 
    
    ' One Wire Values .
     CVRT_TEMP  = $44
     SKIP_ROM   = $CC
     RD_SPAD    = $BE
            
Var

       Long TempReading1, TempReading2
   
OBJ

      ow            : "jm_1-wire"
      Max6675       :  "jm_max6675.spin"            '"Max6675_K_thermoCouple"
      pst           : "parallax serial terminal"
      LCD           : "LCD_20x4"
      num           : "simple_numbers"
      f             : "Float32"
      fp            : "FloatString"

          
'====================================================================================
PUB _Start    |  TimeCnt_10Hz,  DisplayTime  , ElapsedCnt , index  , AddrVar
'====================================================================================


       Initialize 
     
       LCD.RawSetPos( $40 ) ' "first" line
       LCD.RawWriteStr( string("Max6675:") )

       LCD.RawSetPos( $14 )                              {set lcd position}  
       LCD.PrintStr( String("DS1820 :"))
        waitcnt(clkfreq *2 + cnt) 
    
        repeat

              Get_Max6675_Reading
              Get_DS1820_Reading
              waitcnt(clkfreq  + cnt)    'dont scan too fast or the conversion will not run
         
             
'====================================================================================
Pub  Initialize | status
'====================================================================================
      
    'waitcnt(clkfreq*3 + cnt)                          'Give time to open terminal if not auto
    pst.start(115_200)                                 'Start Debug Serial Terminal 
    pst.str(string(13,"Serial Terminal : Ready.",13))  'Lets us know the driver is working
    waitcnt(clkfreq + cnt)

    pst.str(string(13,"Start LCD Driver.",13))         'Start 20x4 Char LCD Driver
    LCD.Init( E, RS, RW, DBHigh, DBLow )
    LCD.Clear
    LCD.usDelay( 2_000_000 )
    LCD.RawSetPos( $00 ) ' "first" line
    LCD.RawWriteStr( string("LCD Started : Succes") )    'Lets us know the driver is working 
    waitcnt(clkfreq *2+ cnt)
    LCD.Clear                                               'Clear Back the screen 
    
        
    Max6675.start(CS, SCK, So)                              'Ini Max6675 

    ow.init(DS1820_D_PIN)                                   'Ini DS1820 Temp Sensor  ( Used as reference )

    

'====================================================================================     
PUB Get_Max6675_Reading  
'====================================================================================
           
      TempReading1 := Max6675.tc01                              'Get reading from MAX6675 

      pst.Str(String("Max6675 Temperture in Celsius = "))      'Display in terminal 
      pst.dec (TempReading1)                                    'Display in terminal
      pst.Str(String(" ",13))                                   'Display in terminal
  
      LCD.RawSetPos( $48 )                                      'set lcd position
      LCD.PrintStr(num.dec(TempReading1))                       'Display on LCD


      
'====================================================================================     
PUB Get_DS1820_Reading  
'====================================================================================
           
      TempReading2 := readtc                                    'Get reading from DS1820 sensor 

      pst.Str(String("DS1820 Temperture in Celsius = "))      'Display in terminal 
      pst.dec (TempReading2)                                    'Display in terminal
      pst.Str(String(" ",13))                                   'Display in terminal

      LCD.RawSetPos( $1C )                                      'set lcd position  
      LCD.PrintStr(num.dec(TempReading2))                       'Display on LCD 
      
     
'====================================================================================
pub readtc | tc
'====================================================================================
'' Reads temperature from DS1820
'' -- returns degrees C in 0.1 degree units

  ow.reset               
  ow.write(SKIP_ROM)          
  ow.write(CVRT_TEMP)          
  repeat                                                        ' let conversion finish                 
    tc := ow.rdbit     
  until (tc == 1)    
  ow.reset               
  ow.write(SKIP_ROM)          
  ow.write(RD_SPAD)          
  tc := ow.read                                                 ' lsb of temp      
  tc |= ow.read << 8                                            ' msb of temp
  ow.reset

  tc := ~~tc * 5                                                ' extend sign, 0.1° units

  return tc       